Attribute VB_Name = "Module2"
Function OpenWBConnection() As Integer
    
    On Error GoTo ErrorHandler
    Dim wrk_WB_ODBC As Workspace
    Dim conn_WB As Connection
    Dim conLoop As Connection
    Dim rset_WB_adresy As Recordset
    Dim strMessage As String
            
' Vytvoen objekt ODBCDirect Workspace.
    Set wrk_WB_ODBC = CreateWorkspace("NewWBODBCWorkspace", "", "", dbUseODBC)
        
    
' Oteven objektu Connection, kter pouv informace zadan v dialogu Sprvce ovladae ODBC.
'    MsgBox "Openning Connection..."
'    Set conn_WB = wrk_WB_ODBC.OpenConnection("Conn_WB_ODBC", _
'        dbDriverPrompt, False, "ODBC;")
    

' Oteven objektu Connection pomoc informac zadanch v poslednm parametru - bez interakce
'MsgBox "Openning direct Connection2..."
    Set conn_WB = wrk_WB_ODBC.OpenConnection("Conn_WB_ODBC", _
        dbDriverNoPrompt, False, _
        "ODBC;DSN=WinBase602_wb6;UID=Honza;PWD=;SCHEMA=Faktura;")
    
    ' Vype kolekci Connections.
    For Each conLoop In wrk_WB_ODBC.Connections
        Debug.Print " Connection properties for " & conLoop.Name & ":"
        With conLoop
' Vytiskne hodnoty vlastnost pomoc explicitnho voln kadho objektu
' Property. Objekt Connection nespolupracuje skolekc Properties.
            Debug.Print "    Connect = " & .Connect
            Debug.Print "    Database[.Name] = " & .Database.Name
            Debug.Print "    Name = " & .Name
            Debug.Print "    Updatable = " & .Updatable
        End With
    Next conLoop
    
' Oteven zdroje dat - urit funguje dbOpenDynaset(bookmarkable a updatable) a dbOpenDynamic(updatable)
'    Debug.Print " Opening dynamic-type editable recordset from an ODBC connection..."
    Set rset_WB_adresy = conn_WB.OpenRecordset("SELECT * FROM Adresy", dbOpenDynamic, dbExecDirect, dbOptimistic)
'    Set rset_WB_adresy = conn_WB.OpenRecordset("SELECT * FROM Adresy", dbOpenDynaset, dbExecDirect, dbOptimistic)
'    Set rset_WB_adresy = conn_WB.OpenRecordset("SELECT * FROM Adresy", dbOpenSnapshot)        'needitovatelne

' vypsat obsah Recordsetu (podle helpu VB)
    OpenRecordsetOutput rset_WB_adresy
    
    Debug.Print "    RecordsAffected after SELECT= " & conn_WB.RecordsAffected
    If rset_WB_adresy.Bookmarkable Then Debug.Print "Bookmarkable"
    
' ukzka editace vybranho zznamu
    With rset_WB_adresy
      .MoveFirst
      If .Updatable Then
       .Edit
       !Firma = "zmnn hodnota"
       .Update
       
       .AddNew
       !Firma = "nov hodnota"
       .Update
       
    '   .Bookmark = .LastModified
    '   .Delete
       
       .MoveFirst
       .Edit
       !Firma = "Vonsek a syn"
       .Update
      End If
    End With

' ukzka editace aktulnho zznamu a prchod vemi zznamy
   Debug.Print "Prchod recordsetem s pepsnm hodnoty"
   Dim col As Field
   With rset_WB_adresy
     Do Until .EOF
        Debug.Print "Zznam .: " & .AbsolutePosition + 1
        If .Updatable Then
           .Edit
           !fax = 999
           .Update
        End If
        For Each col In .Fields
            If col.Type < 11 Then
                Debug.Print col.Name, col.Value
            Else
                Debug.Print col.Name, "velikost:"; col.FieldSize
                If col.FieldSize > 0 Then
                    Debug.Print , "prvnch 20 bajt: "; col.GetChunk(0, 20)
                End If
            End If
        Next
        Debug.Print "---------"
        .MoveNext    ' Posun o jeden zznam
     Loop
   End With

' uzaven recordsetu (odemkne tabulku)
  rset_WB_adresy.Close
    
' ukzka pedn libovolnho SQL pkazu serveru
    strMessage = conn_WB.Connect
    strMessage = "CALL A(""" & strMessage & """)"
    conn_WB.Execute strMessage ', dbExecDirect       ' me se pout i ExecDirect
    conn_WB.Execute "DELETE FROM ADRESY WHERE (Adresy.firma2 Is Null)", dbExecDirect
    conn_WB.Execute "CALL Free_deleted(""Adresy"")"   ' nejde, dokud nen zaven RecordSet rset_WB_adresy

    
    MsgBox "Konec - OK"

KONEC:
    conn_WB.Close
    wrk_WB_ODBC.Close

    
Exit Function

ErrorHandler:
' Zobrazen informac o chyb.
    MsgBox "slo chyby " & Err.Number & ": " & Err.Description
    Resume KONEC:
End Function


Sub OpenRecordsetOutput(rstOutput As Recordset)
    
    ' Vype uren objekt Recordset.
    With rstOutput
      Do While Not .EOF
        Debug.Print , .Fields(0), .Fields(1), .Fields(2), .Fields(3)
        .MoveNext
      Loop
    End With

End Sub


 Sub Main()
    Screen.MousePointer = 11
    StartForm.Show
    StartForm.Refresh
    Screen.MousePointer = 0
    OpenWBConnection
End Sub


